%INCLUDE "support.asm"

;=============================================================================
; Code
;=============================================================================

SECTION .text

   mt_mangle Average, average8_isse
   mt_mangle Average, average8_3dnow
   
%MACRO MT_AVERAGE_ROLLED 0
   movq           mm0, [edi + eax]
   pavgb          mm0, [esi + eax]
   movq           [edi + eax], mm0
%ENDMACRO

%MACRO MT_AVERAGE_UNROLLED 2
   %1             edi + eax + 256
   %2             esi + eax + 256

   movq           mm0, [edi + eax]
   movq           mm1, [edi + eax + 8]
   movq           mm2, [edi + eax + 16]
   movq           mm3, [edi + eax + 24]
   movq           mm4, [edi + eax + 32]
   movq           mm5, [edi + eax + 40]
   movq           mm6, [edi + eax + 48]
   movq           mm7, [edi + eax + 56]
   pavgb          mm0, [esi + eax]
   pavgb          mm1, [esi + eax + 8]
   pavgb          mm2, [esi + eax + 16]
   pavgb          mm3, [esi + eax + 24]
   pavgb          mm4, [esi + eax + 32]
   pavgb          mm5, [esi + eax + 40]
   pavgb          mm6, [esi + eax + 48]
   pavgb          mm7, [esi + eax + 56]
   movq           [edi + eax], mm0
   movq           [edi + eax + 8], mm1
   movq           [edi + eax + 16], mm2
   movq           [edi + eax + 24], mm3
   movq           [edi + eax + 32], mm4
   movq           [edi + eax + 40], mm5
   movq           [edi + eax + 48], mm6
   movq           [edi + eax + 56], mm7
%ENDMACRO

%MACRO MT_AVERAGE_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
   add                  esi, [esp + .nSrcPitch]
%ENDMACRO

average8_isse:
   MT_SUPPORT_COMMON    AVERAGE, MT_PREFETCHT0, MT_PREFETCHT0
   
average8_3dnow:
   MT_SUPPORT_COMMON    AVERAGE, MT_PREFETCHW, MT_PREFETCHT0  
