%INCLUDE "support.asm"

;=============================================================================
; Code
;=============================================================================

SECTION .text

   mt_mangle MakeDiff, makediff8_mmx
   mt_mangle MakeDiff, makediff8_isse
   mt_mangle MakeDiff, makediff8_3dnow
   
%MACRO MT_MAKEDIFF_ROLLED 0
   MT_SUPPORT_DIFF_ROLLED psubsb
%ENDMACRO

%MACRO MT_MAKEDIFF_UNROLLED 2
   MT_SUPPORT_DIFF_UNROLLED %1, %2, psubsb
%ENDMACRO

%MACRO MT_MAKEDIFF_ENDLINE 0
   add                  edi, [esp + .nDstPitch]
   add                  esi, [esp + .nSrcPitch]
%ENDMACRO

makediff8_mmx:
   MT_SUPPORT_COMMON    MAKEDIFF, MT_NOPREFETCH, MT_NOPREFETCH
   
makediff8_isse:
   MT_SUPPORT_COMMON    MAKEDIFF, MT_PREFETCHT0, MT_PREFETCHT0
   
makediff8_3dnow:
   MT_SUPPORT_COMMON    MAKEDIFF, MT_PREFETCHW, MT_PREFETCHT0
